//*****************************************************************************
//*
//*
//*		ConfigDlg.cpp
//*
//*
//*****************************************************************************
// ConfigDlg.cpp: Implementierungsdatei
//
#include	"StdAfx.h"
#include	"IpSwitcher.h"
#include	"NetFunctions.h"
#include	"ConfigDlg.h"
#include	"KeyDialog.h"

#ifdef		_DEBUG
#define new	 DEBUG_NEW
#undef		 THIS_FILE
static char	 THIS_FILE[] = __FILE__;
#endif

BEGIN_MESSAGE_MAP(CConfigDlg, CDialog)
	//{{AFX_MSG_MAP(CConfigDlg)
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_ADD, OnAdd)
	ON_BN_CLICKED(IDC_DEL, OnDel)
	ON_BN_CLICKED(IDC_EDIT, OnEdit)
	ON_NOTIFY(NM_DBLCLK      , IDC_LIST3, OnDoubleClick)
	ON_NOTIFY(LVN_ITEMCHANGED, IDC_LIST3, OnSelKey)
	ON_NOTIFY(LVN_ITEMCHANGED, IDC_LIST1, OnSelChanged)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

//*****************************************************************************
//*
//*		CDialog
//*
//*****************************************************************************
CConfigDlg::CConfigDlg(CWnd *pParent) : CDialog(CConfigDlg::IDD,pParent)
{
	//{{AFX_DATA_INIT(CConfigDlg)
	m_bDontClose   = FALSE;	 
	//}}AFX_DATA_INIT

	m_iCurSelected = -1;
	m_bSelChanged  = FALSE;
	m_bKeyChanged  = FALSE;
}


//*****************************************************************************
//*
//*		DoDataExchange
//*
//*****************************************************************************
void CConfigDlg::DoDataExchange(CDataExchange *pDX)
{
	CDialog::DoDataExchange(pDX);
	
	//{{AFX_DATA_MAP(CConfigDlg)
	DDX_Control(pDX,IDC_LIST3,m_cNameList);
	DDX_Control(pDX,IDC_LIST2,m_cAddrList);
	DDX_Control(pDX,IDC_LIST1,m_cCardList);
	DDX_Check  (pDX,IDC_CHECK1,m_bDontClose);
	//}}AFX_DATA_MAP

}


//*****************************************************************************
//*
//*		OnInitDialog
//*
//*****************************************************************************
//  Behandlungsroutinen fr Nachrichten CConfigDlg
BOOL CConfigDlg::OnInitDialog()
{
CRegKeys		sKey;
LPCTSTR			pName;
CString			sText;
NetCardInfo    *pInfo;
unsigned		uItem;
unsigned		uPos;
LRESULT			lRet;


	sKey.Open(HKEY_CURRENT_USER,"Software\\AZ\\IpSwitcher");
	sKey.Get(m_bDontClose,"DontClose");

	m_bKeyChanged = FALSE;

	CDialog::OnInitDialog();

	
	m_cCardList.SetExtendedStyle(LVS_EX_FULLROWSELECT|LVS_EX_CHECKBOXES|m_cCardList.GetExtendedStyle());
	m_cCardList.InsertColumn(0,"Beschreibung"   ,LVCFMT_LEFT,ColSize(m_cCardList,155,70+55+50+155));
	m_cCardList.InsertColumn(1,"Name"			,LVCFMT_LEFT,ColSize(m_cCardList, 70,70+55+50+155));
	m_cCardList.InsertColumn(2,"MAC-Adresse"	,LVCFMT_LEFT,ColSize(m_cCardList, 55,70+55+50+155));
	m_cCardList.InsertColumn(3,"IP-Adresse"		,LVCFMT_LEFT,ColSize(m_cCardList, 50,70+55+50+155));

	m_cAddrList.SetExtendedStyle(LVS_EX_FULLROWSELECT|m_cAddrList.GetExtendedStyle());
	m_cAddrList.InsertColumn(0,"Beschreibung"   ,LVCFMT_LEFT,ColSize(m_cAddrList,100,100+100));
	m_cAddrList.InsertColumn(1,"MAC-Adresse"	,LVCFMT_LEFT,ColSize(m_cAddrList,100,100+100));

	m_cNameList.SetExtendedStyle(LVS_EX_FULLROWSELECT|m_cNameList.GetExtendedStyle());
	m_cNameList.InsertColumn(0,"Tasten"			,LVCFMT_LEFT,ColSize(m_cNameList,100,100+70));
	m_cNameList.InsertColumn(1,"IP-Adresse"		,LVCFMT_LEFT,ColSize(m_cNameList, 70,100+70));
	
	
	m_uCards = NetUpdateCards();	

	for(uPos=0;uPos<m_uCards;uPos++)				// Karten einfgen
		{
		pInfo = NetGetCardInfo(uPos);     
		uItem = m_cCardList.InsertItem(uPos,pInfo->cDesciption);

		m_cCardList.SetItemText(uItem,1,pInfo->cInfoName);
		m_cCardList.SetItemText(uItem,2,pInfo->cMac     );
		m_cCardList.SetItemText(uItem,3,pInfo->cFirstIp );

		if(m_sMacSelect.Find(pInfo->cMac,0,-1,1)>=0)
			{
			m_cCardList.SetItemState(uPos,0x2000,LVIS_STATEIMAGEMASK);
			}
		}

	if(m_uCards>0)
		{
		m_cCardList.SetItemState(0,LVIS_SELECTED,LVIS_SELECTED);
		}



	sKey.Open(HKEY_CURRENT_USER,"Software\\AZ\\IpSwitcher\\Keys");



	for(uPos=0;uPos<256;uPos++)
		{
			pName = sKey.KeySubName(uPos);
		if(!pName)break;

		uItem = m_cNameList.InsertItem(uPos,pName);
		
		if(sKey.Up(pName,TRUE))
			{
			sText="";
			sKey.Get(sText,"IpAddress");
			m_cNameList.SetItemText(uItem,1,sText);
			sKey.Down();
			}
		}


	OnSelKey(NULL,&lRet);


return TRUE;
}

//*****************************************************************************
//*
//*		OnDestroy
//*
//*****************************************************************************
void CConfigDlg::OnDestroy()
{
	CDialog::OnDestroy();


}

//*****************************************************************************
//*
//*		ColSize
//*
//*****************************************************************************
int CConfigDlg::ColSize(CListCtrl &cList,int iSize,int iFull)
{
CRect	sRect;
int		iMax;


	cList.GetClientRect(&sRect);
	iMax  = sRect.Width();
	iMax -= GetSystemMetrics(SM_CYHSCROLL);
	iMax *= iSize;
	iMax /= iFull;


	if(iMax<iSize/2)iMax=iSize/2;



return iMax;
}

//*****************************************************************************
//*
//*		OnOK
//*
//*****************************************************************************
void CConfigDlg::OnOK()
{
NetCardInfo    *pInfo;
CStringChain	sList;
CRegKeys		sKey;
unsigned		uBits;
unsigned		uPos;
int				iNum;



	UpdateData();

	sKey.Open(HKEY_CURRENT_USER,"Software\\AZ\\IpSwitcher");
	sKey.Set(m_bDontClose,"DontClose");


	m_bSelChanged = FALSE;


	for(uPos=0,iNum=0;uPos<m_uCards;uPos++)			
		{
		pInfo = NetGetCardInfo(uPos);     
		uBits = m_cCardList.GetItemState(uPos,LVIS_STATEIMAGEMASK)&LVIS_STATEIMAGEMASK;
		if(uBits!=0x2000)continue;
		
		if(sList.Count()+1>=m_sMacSelect.Count())
			{
			m_bSelChanged = TRUE;
			}

		sList.Add(pInfo->cMac);
		}

	if(sList.Count()!=m_sMacSelect.Count())
		{
		m_bSelChanged = TRUE;
		}
	
	m_sMacSelect = sList;



	CDialog::OnOK();

}

//*****************************************************************************
//*
//*		OnCancel
//*
//*****************************************************************************
void CConfigDlg::OnCancel()
{

	CDialog::OnCancel();
}

//*****************************************************************************
//*
//*		OnAdd
//*
//*****************************************************************************
void CConfigDlg::OnAdd()
{
POSITION		hPos;
CKeyDialog		sDlg;
CString			sName;
int				iItem;	


	
	hPos	= m_cCardList.GetFirstSelectedItemPosition();
	iItem	= m_cCardList.GetNextSelectedItem(hPos);

	if(iItem>=0)sDlg.m_iCard=iItem;

	
	if(sDlg.DoModal()!=IDOK)return;

	for(iItem=m_cNameList.GetItemCount()-1;iItem>=0;iItem--)
		{
		   sName =m_cNameList.GetItemText(iItem,0);
		if(sName==sDlg.m_sName)return;
		}
	
	if(sDlg.m_bChanged)
		{
		m_bKeyChanged = TRUE;
		}

	iItem = m_cNameList.InsertItem (iItem,  sDlg.m_sName);
	        m_cNameList.SetItemText(iItem,1,sDlg.m_sAddr);

}

//*****************************************************************************
//*
//*		OnDel
//*
//*****************************************************************************
void CConfigDlg::OnDel()
{
POSITION		hPos;
CRegKeys		sKey;	
CString			sName;
int				iItem;	


	
	hPos	= m_cNameList.GetFirstSelectedItemPosition();
	iItem	= m_cNameList.GetNextSelectedItem(hPos);

	if(iItem<0)return;

	sName	= m_cNameList.GetItemText(iItem,0);

	   sKey.Open(HKEY_CURRENT_USER,"Software\\AZ\\IpSwitcher\\Keys");
	if(sKey.DelKey(sName))
		{
		m_bKeyChanged = TRUE;
		}
	
	m_cNameList.DeleteItem(iItem);
	
}

//*****************************************************************************
//*
//*		OnEdit
//*
//*****************************************************************************
void CConfigDlg::OnEdit() 
{
POSITION		hPos;
CKeyDialog		sDlg;
int				iItem;	


	
	hPos	= m_cNameList.GetFirstSelectedItemPosition();
	iItem	= m_cNameList.GetNextSelectedItem(hPos);

	if(iItem<0)return;

	sDlg.m_sName = m_cNameList.GetItemText(iItem,0);

	if(sDlg.DoModal()!=IDOK)return;

	if(sDlg.m_bChanged)
		{
		m_cNameList.SetItemText(iItem,0,sDlg.m_sName);
		m_cNameList.SetItemText(iItem,1,sDlg.m_sAddr);
		m_bKeyChanged = TRUE;
		}


	
}

//*****************************************************************************
//*
//*		SortIpList
//*
//*****************************************************************************
int CConfigDlg::SortIpList(const void *pPtr1,const void *pPtr2)
{
LPDWORD		pData1=(LPDWORD)pPtr1;
LPDWORD		pData2=(LPDWORD)pPtr2;


	if(btol_dw(*pData1)<btol_dw(*pData2))return -1;
	if(btol_dw(*pData1)>btol_dw(*pData2))return  1;


return 0;
}

//*****************************************************************************
//*
//*		OnDoubleClick
//*
//*****************************************************************************
void CConfigDlg::OnDoubleClick(NMHDR* pNMHDR, LRESULT* pResult)
{
POSITION		hPos;
int				iItem;	
	
	
	hPos	= m_cCardList.GetFirstSelectedItemPosition();
	iItem	= m_cCardList.GetNextSelectedItem(hPos);

	if(iItem<0)return;

	OnEdit();

}

//*****************************************************************************
//*
//*		OnSelChanged
//*
//*****************************************************************************
void CConfigDlg::OnSelChanged(NMHDR *pNMHDR,LRESULT *pResult) 
{
DWORD			aList[64*2];
TCHAR			cText[64];
NetCardInfo    *pInfo;
POSITION		hPos;
int				iItem;	
int				iCnt;
int				iPos;
	
	
	hPos	= m_cCardList.GetFirstSelectedItemPosition();
	iItem	= m_cCardList.GetNextSelectedItem(hPos);

	if(iItem==m_iCurSelected)
		{
		return;
		}

	
	m_cAddrList.DeleteAllItems();
	
	m_iCurSelected = iItem;

	if(iItem>=0)										// Ist eine Karte gewhlt	
		{
		pInfo = NetGetCardInfo(iItem);     
		iCnt  = NetGetIpAddresses(pInfo->cMac,aList,64,0x03);

		qsort(aList,iCnt,sizeof(DWORD)*2,SortIpList);

		for(iPos=0;iPos<iCnt;iPos++)
			{
			if(!aList[iPos*2+0] && !aList[iPos*2+1])
				{
				m_cAddrList.InsertItem(iPos,"DHCP");
				continue;
				}

			NetIpAddressToText(aList[iPos*2+0],cText);
			m_cAddrList.InsertItem(iPos,cText);
			NetIpAddressToText(aList[iPos*2+1],cText);
			m_cAddrList.SetItemText(iPos,1,cText);
			}
		
		if(pInfo->cGateway[0])
			{
			m_cAddrList.InsertItem (iPos,pInfo->cGateway);
			m_cAddrList.SetItemText(iPos,1,"Gateway");
			iPos++;
			}

		if(pInfo->cNameSrv1[0])
			{
			m_cAddrList.InsertItem (iPos,pInfo->cNameSrv1);
			m_cAddrList.SetItemText(iPos,1,"Name-Server-1");
			iPos++;
			}

		if(pInfo->cNameSrv2[0])
			{
			m_cAddrList.InsertItem (iPos,pInfo->cNameSrv2);
			m_cAddrList.SetItemText(iPos,1,"Name-Server-2");
			iPos++;
			}
		}

	*pResult = 0;
}


//*****************************************************************************
//*
//*		OnSelKey
//*
//*****************************************************************************
void CConfigDlg::OnSelKey(NMHDR *pNMHDR,LRESULT *pResult) 
{
POSITION		hPos;
int				iItem;	
	
	
	hPos	= m_cNameList.GetFirstSelectedItemPosition();
	iItem	= m_cNameList.GetNextSelectedItem(hPos);

	m_iCurSelected = iItem;

	GetDlgItem(IDC_DEL )->EnableWindow(iItem>=0);
	GetDlgItem(IDC_EDIT)->EnableWindow(iItem>=0);

	*pResult = 0;
}

