//*****************************************************************************
//*
//*
//*		IpSwitcherDlg.cpp
//*
//*
//*****************************************************************************
#include	"StdAfx.h"
#include	"IpSwitcher.h"
#include	"IpSwitcherDlg.h"
#include	"NetFunctions.h"
#include	"ConfigDlg.h"

#define 	 IDC_INFO		0x2000
#define 	 IDC_BUTTON		0x3000
#define 	 ADD			4

#ifdef		_DEBUG
#define new	 DEBUG_NEW
#undef		 THIS_FILE
static char	 THIS_FILE[] = __FILE__;
#endif

BEGIN_MESSAGE_MAP(CIpSwitcherDlg, CDialog)
	//{{AFX_MSG_MAP(CIpSwitcherDlg)
	ON_WM_PAINT()
//	ON_WM_CTLCOLOR()
	ON_WM_SYSCOMMAND()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_CONFIG, OnConfig)
	ON_BN_CLICKED(IDC_SELECT, OnSelect)
	ON_COMMAND_RANGE(IDC_BUTTON,IDC_BUTTON+MAX_BUTTONS,OnSelectBt)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

CBrush	hBg1Brush(RGB(  0,192,192));
CBrush	hBg2Brush(RGB(255,128,255));

//*****************************************************************************
//*
//*		CDialog
//*
//*****************************************************************************
CIpSwitcherDlg::CIpSwitcherDlg(CWnd *pParent) : CDialog(CIpSwitcherDlg::IDD,pParent)
{
	//{{AFX_DATA_INIT(CIpSwitcherDlg)
	//}}AFX_DATA_INIT

	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_uIpInfoCnt = 0;	
	m_uButtonCnt = 0;

}

//*****************************************************************************
//*
//*		DoDataExchange
//*
//*****************************************************************************
void CIpSwitcherDlg::DoDataExchange(CDataExchange *pDX)
{
	CDialog::DoDataExchange(pDX);

	//{{AFX_DATA_MAP(CIpSwitcherDlg)
	//}}AFX_DATA_MAP
}

//*****************************************************************************
//*
//*		OnInitDialog
//*
//*****************************************************************************
BOOL CIpSwitcherDlg::OnInitDialog()
{
CMenu  *pSysMenu;
		


	CDialog::OnInitDialog();



	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT( IDM_ABOUTBOX < 0xF000);

	pSysMenu = GetSystemMenu(FALSE);
	
	if(pSysMenu != NULL)
		{
		CString		sAboutMenu;

			sAboutMenu.LoadString(IDS_ABOUTBOX);
		if(!sAboutMenu.IsEmpty())
			{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, sAboutMenu);
			}
		}

	SetIcon(m_hIcon,TRUE );
	SetIcon(m_hIcon,FALSE);
	
	UpdateLayout();


return TRUE; 
}

//*****************************************************************************
//*
//*		OnSysCommand
//*
//*****************************************************************************
void CIpSwitcherDlg::OnSysCommand(UINT nID,LPARAM lParam)
{
	if((nID&0xFFF0) == IDM_ABOUTBOX)
		{
		CDialog		sDlg(IDD_ABOUTBOX);

		sDlg.DoModal();
		}
	else{
		CDialog::OnSysCommand(nID, lParam);
		}
}

//*****************************************************************************
//*
//*		OnPaint
//*
//*****************************************************************************
void CIpSwitcherDlg::OnPaint()
{
	if(IsIconic())
		{
		CPaintDC dc(this);										// Gertekontext fr Zeichnen

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Symbol in Client-Rechteck zentrieren
		
		int iIconX = GetSystemMetrics(SM_CXICON);
		int iIconY = GetSystemMetrics(SM_CYICON);
		
		CRect sRect;

		GetClientRect(&sRect);
		int iSizeX = (sRect.Width ()-iIconX+1) / 2;
		int iSizeY = (sRect.Height()-iIconY+1) / 2;

		dc.DrawIcon(iSizeX,iSizeY,m_hIcon);
		}
	else{
		CDialog::OnPaint();
		}
}

//*****************************************************************************
//*
//*		OnQueryDragIcon
//*
//*****************************************************************************
HCURSOR CIpSwitcherDlg::OnQueryDragIcon()
{

return (HCURSOR) m_hIcon;
}

//*****************************************************************************
//*
//*		OnOK
//*
//*****************************************************************************
void CIpSwitcherDlg::OnOK()
{

	CDialog::OnOK();
}

//*****************************************************************************
//*
//*		OnCancel
//*
//*****************************************************************************
void CIpSwitcherDlg::OnCancel()
{

	CDialog::OnCancel();
}

//*****************************************************************************
//*
//*		OnConfig
//*
//*****************************************************************************
void CIpSwitcherDlg::OnConfig() 
{
CConfigDlg	sDlg;
CRegKeys	sKey;
LPTSTR		pMac;
BOOL		bNew;


	bNew = FALSE;
	sKey.Open(HKEY_CURRENT_USER,"Software\\AZ\\IpSwitcher");
	sKey.GetMulti(&pMac,"MacSelect");

	if(pMac)
		{
		sDlg.m_sMacSelect.KAdd(pMac);
		delete pMac;
		}


	if(sDlg.DoModal()==IDOK)
		{
		if(sDlg.m_bSelChanged)
			{
			sDlg.m_sMacSelect.Chain(&pMac);
			sKey.SetMulti(pMac,"MacSelect");
			delete pMac;
			bNew = TRUE;
			}
		}
		
	if(sDlg.m_bKeyChanged || bNew)
		{
		UpdateLayout();
		}
	
}


//*****************************************************************************
//*
//*		UpdateLayout
//*
//*****************************************************************************
void CIpSwitcherDlg::UpdateLayout()
{
TCHAR			cText[256];
DWORD			aAddr[2];
NetCardInfo    *pInfo;
CString			sOld;
CRegKeys		sKey;
CRect			sSize;
CRect			sRect;
LPTSTR			pKey;
LPTSTR			pMac;
UINT			uMax;
UINT			uNum;
UINT			uPos;
int				iOff;
int				iLen;


	
	NetUpdateCards();

	
	sKey.Open(HKEY_CURRENT_USER,"Software\\AZ\\IpSwitcher",CRK_READ);
	sKey.GetMulti(&pMac,"MacSelect");

	if(!pMac)
		{
		pMac    = new TCHAR[256];
		pInfo	= NetGetCardInfo(0);

		if(pInfo)
			{
			iLen = strlcpy(pMac,pInfo->cMac,sizeof(pInfo->cMac));
			pMac[iLen+1]=0;
			}
		else{
			pMac[0] = 0;
			pMac[1] = 0;
			}
		}


	m_sList.Del();


	if(sKey.Up("Keys"))										// Tastentexte holen
		{
		for(uPos=0;uPos<256;uPos++)
			{
				pKey = sKey.KeySubName(uPos);
			if(!pKey)break;

			m_sList.Add(pKey,CSC_ABCG);
			}
		}



	GetDlgPosRect(this,IDC_TEXT  ,&sRect);					// Info-Fenster erzeugen
	GetDlgPosRect(this,IDC_CONFIG,&sSize);


	while(m_uIpInfoCnt<MAX_IPINFO)
		{
		m_aIpInfo[m_uIpInfoCnt].CreateEx(WS_EX_CLIENTEDGE,"STATIC","",WS_CHILD|SS_CENTER,sRect,this,IDC_INFO+m_uIpInfoCnt);
		m_aIpInfo[m_uIpInfoCnt].SetFont(CFont::FromHandle((HFONT)GetStockObject(ANSI_VAR_FONT)));
		m_uIpInfoCnt++;
		}

	while(m_uButtonCnt<MAX_BUTTONS)							// Tasten erzeugen
		{
		m_aButtons[m_uButtonCnt].Create("",WS_CHILD|WS_TABSTOP,sRect,this,IDC_BUTTON+m_uButtonCnt);
		m_aButtons[m_uButtonCnt].SetFont(CFont::FromHandle((HFONT)GetStockObject(ANSI_VAR_FONT)));
		m_uButtonCnt++;
		}

	
	for(iOff=0,uPos=0;;iOff+=iLen)							// IP-Adressen anzeigen
		{
		iLen = strlen(pMac+iOff)+1;
		if(iLen<=1)break;

		uNum = NetGetIpAddresses(pMac+iOff,aAddr,1,0x03);

		if(uNum==0)
			{
			m_aIpInfo[uPos].SetWindowText("---");
			}
		else if(aAddr[0]==0 && aAddr[1]==0)
			{
			m_aIpInfo[uPos].SetWindowText("DHCP");
			}
		else{
			NetIpAddressToText(aAddr[0],cText);
			m_aIpInfo[uPos].SetWindowText(cText);
			}
		
		m_aIpInfo[uPos].MoveWindow(&sRect);
		m_aIpInfo[uPos].ShowWindow(SW_SHOW);		
		sRect.OffsetRect(0,sRect.Height()+ADD);
		uPos++;
		}
	
	
	if(uPos==0)												// Keine Info-Fenster
		{
		sRect.OffsetRect(0,6);
		}


	for(;uPos<m_uIpInfoCnt;uPos++)							// Unsichtbare Fenster ausblenden
		{
		m_aIpInfo[uPos].ShowWindow(SW_HIDE);
		}	


	sRect.bottom = sRect.top+sSize.Height();
	uMax = MAX_BUTTONS;

	if(m_sList.Count()>MAX_BUTTONS)							// Mit ComboBox anzeigen
		{
		GetDlgItem(IDC_COMBO1)->MoveWindow(&sRect);
		sRect.OffsetRect(0,sRect.Height()+2);
		GetDlgItem(IDC_SELECT)->MoveWindow(&sRect);
		sRect.OffsetRect(0,sRect.Height()+ADD+6);
		uMax = MAX_BUTTONS-1;

		iOff = GetDlgComboBox(IDC_COMBO1)->GetCurSel();
		if(iOff>=0)GetDlgComboBox(IDC_COMBO1)->GetLBText(iOff,sOld);
		GetDlgComboBox(IDC_COMBO1)->ResetContent();

		for(iOff=0;iOff<m_sList.Count();iOff++)
			{
			uPos = GetDlgComboBox(IDC_COMBO1)->AddString(m_sList[iOff]);	
			if(sOld==m_sList[iOff])
				{
				GetDlgComboBox(IDC_COMBO1)->SetCurSel(uPos);
				sOld="*";
				}
			}

		if(sOld!="*")GetDlgComboBox(IDC_COMBO1)->SetCurSel(0);

		GetDlgItem(IDC_COMBO1)->ShowWindow(SW_SHOW);		
		GetDlgItem(IDC_SELECT)->ShowWindow(SW_SHOW);		
		}
	else{
		GetDlgItem(IDC_COMBO1)->ShowWindow(SW_HIDE);		
		GetDlgItem(IDC_SELECT)->ShowWindow(SW_HIDE);		
		}


	for(uPos=0;uPos<uMax;uPos++)							// Tasten anzeigen
		{
		if(uPos>=(UINT)m_sList.Count())break;
		m_aButtons[uPos].SetWindowText(m_sList[uPos]);
		m_aButtons[uPos].MoveWindow(&sRect);
		m_aButtons[uPos].ShowWindow(SW_SHOW);		
		sRect.OffsetRect(0,sRect.Height()+ADD);
		}
	
	for(;uPos<m_uButtonCnt;uPos++)							// Unsichtbare Fenster ausblenden
		{
		m_aButtons[uPos].ShowWindow(SW_HIDE);
		}	


	delete pMac;	


	GetWindowRect(&sSize);
	sSize.bottom = sSize.top+sRect.bottom+12;
	SetWindowPos(NULL,0,0,sSize.Width(),sSize.Height(),SWP_NOMOVE|SWP_NOREPOSITION);


}

//*****************************************************************************
//*
//*		UpdateInfos
//*
//*****************************************************************************
void CIpSwitcherDlg::UpdateInfos()
{
TCHAR			cText[256];
DWORD			aAddr[2];
NetCardInfo    *pInfo;
CRegKeys		sKey;
LPTSTR			pMac;
UINT			uNum;
UINT			uPos;
int				iOff;
int				iLen;


	
	NetUpdateCards();

	
	sKey.Open(HKEY_CURRENT_USER,"Software\\AZ\\IpSwitcher",CRK_READ);
	sKey.GetMulti(&pMac,"MacSelect");

	if(!pMac)
		{
		pMac    = new TCHAR[256];
		pInfo	= NetGetCardInfo(0);

		if(pInfo)
			{
			iLen = strlcpy(pMac,pInfo->cMac,sizeof(pInfo->cMac));
			pMac[iLen+1]=0;
			}
		else{
			pMac[0] = 0;
			pMac[1] = 0;
			}
		}




	for(iOff=0,uPos=0;;iOff+=iLen)							// IP-Adressen anzeigen
		{
		iLen = strlen(pMac+iOff)+1;
		if(iLen<=1)break;

		uNum = NetGetIpAddresses(pMac+iOff,aAddr,1,0x03);

		if(uNum==0)
			{
			m_aIpInfo[uPos].SetWindowText("---");
			}
		else if(aAddr[0]==0 && aAddr[1]==0)
			{
			m_aIpInfo[uPos].SetWindowText("DHCP");
			}
		else{
			NetIpAddressToText(aAddr[0],cText);
			m_aIpInfo[uPos].SetWindowText(cText);
			}
		
		uPos++;
		}
	
	delete pMac;	


}

//*****************************************************************************
//*
//*		OnSelect
//*
//*****************************************************************************
void CIpSwitcherDlg::OnSelect() 
{
CString	sName;
int		iSel;

	
	   iSel = GetDlgComboBox(IDC_COMBO1)->GetCurSel();
	if(iSel<0)return;

	GetDlgComboBox(IDC_COMBO1)->GetLBText(iSel,sName);
	
	if(Execute(sName,this))OnOK();

	
}

//*****************************************************************************
//*
//*		OnSelectBt
//*
//*****************************************************************************
void CIpSwitcherDlg::OnSelectBt(UINT nID)
{
CRegKeys	sKey;
BOOL		bDontClose;
int			iErr;


	bDontClose = FALSE;

	sKey.Open(HKEY_CURRENT_USER,"Software\\AZ\\IpSwitcher");
	sKey.Get(bDontClose,"DontClose");

	   nID -= IDC_BUTTON;
	if(nID>=(UINT)m_sList.Count())return;

	SetCursor(IDC_WAIT);
	iErr = Execute(m_sList[nID],this);
	SetCursor(IDC_ARROW);
	
	if(iErr)
		{
		if(!bDontClose)OnOK();
		}

	UpdateInfos();

}

//*****************************************************************************
//*
//*		Execute
//*
//*****************************************************************************
int CIpSwitcherDlg::Execute(LPCTSTR pName,CWnd *pParent)
{
CRegKeys		sKey;
CString			sSrv1;
CString			sSrv2;
CString			sGate;
CString			sCard;
CString			sAddr;
CString			sMask;
int				iMode;
int				iRet;
int				iVal;



	if(!pParent)
		{
		pParent = GetDesktopWindow();
		}
	
	if(!sKey.Open(HKEY_CURRENT_USER,"Software\\AZ\\IpSwitcher\\Keys",CRK_READ))
		{
		pParent->MessageBox("Das Tastenkommando wurde nicht gefunden !","Fehler",MB_OK|MB_ICONERROR);
		return -1;
		}

	if(!sKey.Up(pName))
		{
		pParent->MessageBox("Das Tastenkommando wurde nicht gefunden !","Fehler",MB_OK|MB_ICONERROR);
		return -1;
		}

	sKey.Get(sSrv2,"NameServer2");
	sKey.Get(sSrv1,"NameServer1");
	sKey.Get(sAddr,"IpAddress"  );
	sKey.Get(sMask,"SubnetMask" );
	sKey.Get(sCard,"MacOfCard"  );
	sKey.Get(sGate,"Gateway"    );
	sKey.Get(iMode,"Mode"       );
	

	NetUpdateCards();

	switch(iMode)
		{
	case 0:	iRet=NetSetIpAddress(sCard,sAddr,sMask,0x03);	break;
	case 1:	iRet=NetSetIpAddress(sCard,sAddr,sMask,0x01);	break;
	case 2:	iRet=NetSetIpAddress(sCard,sAddr,sMask,0x02);	break;
	case 3:	iRet=NetSetIpAddress(sCard,sAddr,sMask,0x00);	break;
	case 4:	iRet=NetDelIpAddress(sCard,sAddr      ,0x02);	break;
	case 5:	iRet=NetDelIpAddress(sCard,sAddr      ,0x00);	break;
	default:iRet=999;
		}

	
	if(iMode==0 && sGate!="")								// Gateway einstellen
		{
		if(sGate=="*")sGate="";
		iVal = NetSetGateway(sCard,sGate);
		if(iRet==0)iRet=iVal;
		}

	if(iMode==4 && sGate=="*")								// Gateway lschen
		{
		iVal = NetSetGateway("",sGate);
		if(iRet==0)iRet=iVal;
		}

	if(iMode==0 && (sSrv1!="" || sSrv2!=""))				// Name-Server einstellen
		{
		if(sSrv1=="*")sSrv1="";
		if(sSrv2=="*")sSrv2="";
		iVal = NetSetNameServer(sCard,sSrv1,sSrv2);
		if(iRet==0)iRet=iVal;
		}

	if(iMode==4 && sSrv1=="*")								// Name-Server lschen
		{
		iVal = NetSetNameServer(sCard,"","");
		if(iRet==0)iRet=iVal;
		}


	NetUpdateCards();


	if(iRet==0)
		{
		pParent->MessageBox("Die Einstellungen wurden gemacht !","Information",MB_OK|MB_ICONINFORMATION);
		return 1;
		}

	switch(iRet)
		{
	case 1:	pParent->MessageBox("Keine Netzwerkskarten gefunden !"			,"Fehler",MB_OK|MB_ICONERROR);	break;
	case 2:	pParent->MessageBox("Keine Netzwerkskarten-Info vorhanden !"	,"Fehler",MB_OK|MB_ICONERROR);	break;
	case 3:	pParent->MessageBox("Die Netzwerkskarte wurde nicht gefunden !"	,"Fehler",MB_OK|MB_ICONERROR);	break;
	case 4:	pParent->MessageBox("Falsches Format der IP-Addresse !"			,"Fehler",MB_OK|MB_ICONERROR);	break;
	case 5:	pParent->MessageBox("Falsches Format der SubNet-Maske !"		,"Fehler",MB_OK|MB_ICONERROR);	break;
	case 6:	pParent->MessageBox("Die Adresse existiert bereits  !"			,"Fehler",MB_OK|MB_ICONERROR);	break;
	case 7:	pParent->MessageBox("Kein Zugriff auf Registry !"				,"Fehler",MB_OK|MB_ICONERROR);	break;
	case 8:	pParent->MessageBox("Kein Kabel in der Netzwerkskarte !"		,"Fehler",MB_OK|MB_ICONERROR);	break;
	case 9:	pParent->MessageBox("Die Adresse konnte nicht gesetzt werden !"	,"Fehler",MB_OK|MB_ICONERROR);	break;
	case 10:pParent->MessageBox("Die Adresse konnte nicht gefunden werden !","Fehler",MB_OK|MB_ICONERROR);	break;
	case 11:pParent->MessageBox("Die Adresse konnte nicht gelscht werden !","Fehler",MB_OK|MB_ICONERROR);	break;
	case 12:pParent->MessageBox("Kann OLE-Interface nicht initialisieren !"	,"Fehler",MB_OK|MB_ICONERROR);	break;
	case 13:pParent->MessageBox("Kann WMI-Interface nicht initialisieren !"	,"Fehler",MB_OK|MB_ICONERROR);	break;
	case 14:pParent->MessageBox("Fehler bei WMI Abfrage !"					,"Fehler",MB_OK|MB_ICONERROR);	break;
	default:pParent->MessageBox("Unbekannter Fehler !"						,"Fehler",MB_OK|MB_ICONERROR);	break;
		}


return 0;
}


//*****************************************************************************
//*
//*		OnCtlColor
//*
//*****************************************************************************
HBRUSH CIpSwitcherDlg::OnCtlColor(CDC *pDC,CWnd *pWnd,UINT nCtlColor) 
{


	if(pWnd->m_hWnd==this->m_hWnd)
		{
		pDC->SetBkColor(RGB(0,128,128));
		return hBg1Brush;
		}

	if(nCtlColor==CTLCOLOR_STATIC)
		{
		pDC->SetBkColor(RGB(255,128,255));
		return hBg2Brush;
		}

	

return CDialog::OnCtlColor(pDC,pWnd,nCtlColor);
}

