//*****************************************************************************
//*
//*
//*		KeyDialog.cpp
//*
//*
//*****************************************************************************
// KeyDialog.cpp: Implementierungsdatei
//
#include	"StdAfx.h"
#include	"IpSwitcher.h"
#include	"NetFunctions.h"
#include	"KeyDialog.h"


#ifdef		_DEBUG
#define new	 DEBUG_NEW
#undef		 THIS_FILE
static char	 THIS_FILE[] = __FILE__;
#endif


BEGIN_MESSAGE_MAP(CKeyDialog, CDialog)
	//{{AFX_MSG_MAP(CKeyDialog)
	ON_WM_CTLCOLOR()
	ON_EN_CHANGE(IDC_EDIT1, OnChangeName)
	ON_EN_CHANGE(IDC_EDIT2, OnChangeAddr)
	ON_EN_CHANGE(IDC_EDIT3, OnChangeMask)
	ON_EN_CHANGE(IDC_EDIT4, OnChangeGate)
	ON_EN_CHANGE(IDC_EDIT5, OnChangeSrv1)
	ON_EN_CHANGE(IDC_EDIT6, OnChangeSrv1)
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	ON_BN_CLICKED(IDC_BUTTON3, OnButton3)
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_RADIO1, OnRadio)
	ON_BN_CLICKED(IDC_RADIO2, OnRadio)
	ON_BN_CLICKED(IDC_RADIO3, OnRadio)
	ON_BN_CLICKED(IDC_RADIO4, OnRadio)
	ON_BN_CLICKED(IDC_RADIO5, OnRadio)
	ON_BN_CLICKED(IDC_RADIO6, OnRadio)
END_MESSAGE_MAP()


CBrush	CKeyDialog::m_hErrBrush(RGB(255,128,128));

//*****************************************************************************
//*
//*		CDialog
//*
//*****************************************************************************
CKeyDialog::CKeyDialog(CWnd *pParent) : CDialog(CKeyDialog::IDD,pParent)
{
	//{{AFX_DATA_INIT(CKeyDialog)
	m_sName =  _T("");
	m_sAddr =  _T("");
	m_sMask =  _T("");
	m_sGate =  _T("");
	m_sSrv1 =  _T("");
	m_sSrv2 =  _T("");
	m_iCard =  0;
	m_iMode =  0;
	//}}AFX_DATA_INIT
}


//*****************************************************************************
//*
//*		DoDataExchange
//*
//*****************************************************************************
void CKeyDialog::DoDataExchange(CDataExchange *pDX)
{
BOOL	bOldA;
BOOL	bOldM;
BOOL	bOldN;
BOOL	bOldG;
BOOL	bOld1;
BOOL	bOld2;
int		iOff;

	CDialog::DoDataExchange(pDX);

	//{{AFX_DATA_MAP(CKeyDialog)
	DDX_Text   (pDX,IDC_EDIT1 ,m_sName);
	DDX_Text   (pDX,IDC_EDIT2 ,m_sAddr);
	DDX_Text   (pDX,IDC_EDIT3 ,m_sMask);
	DDX_Text   (pDX,IDC_EDIT4, m_sGate);
	DDX_Text   (pDX,IDC_EDIT5 ,m_sSrv1);
	DDX_Text   (pDX,IDC_EDIT6 ,m_sSrv2);
	DDX_CBIndex(pDX,IDC_COMBO1,m_iCard);
	DDX_Radio  (pDX,IDC_RADIO1,m_iMode);
	//}}AFX_DATA_MAP

	bOldA		= m_bIsAddrOk;
	bOldM		= m_bIsMaskOk;
	bOldN		= m_bIsNameOk;
	bOldG		= m_bIsGateOk;
	bOld1		= m_bIsSrv1Ok;
	bOld2		= m_bIsSrv2Ok;

	iOff		= strwlen(m_sName,0x300000AF);

	m_bIsDhcp	= (stricmp(m_sAddr,"DHCP"))? 0:1;
	m_bIsNameOk = (iOff>0 && ((LPCTSTR)m_sName)[iOff]==0)? 1:0;
	m_bIsAddrOk = (              m_bIsDhcp || NetCheckIpAddress(m_sAddr  )!=0xFFFFFFFF)? 1:0;
	m_bIsMaskOk = (m_iMode>=4 || m_bIsDhcp || NetCheckIpAddress(m_sMask,1)!=0xFFFFFFFF)? 1:0;
	m_bIsGateOk = (m_iMode>=1 || m_sGate=="" || m_sGate=="*" || NetCheckIpAddress(m_sGate)!=0xFFFFFFFF)? 1:0;
	m_bIsSrv1Ok = (m_iMode>=1 || m_sSrv1=="" || m_sSrv1=="*" || NetCheckIpAddress(m_sSrv1)!=0xFFFFFFFF)? 1:0;
	m_bIsSrv2Ok = (m_iMode>=1 || m_sSrv2=="" || m_sSrv2=="*" || NetCheckIpAddress(m_sSrv2)!=0xFFFFFFFF)? 1:0;

	if(m_iMode==4 && !(m_sGate=="" || m_sGate=="*"))
		{
		m_bIsGateOk = 0;
		}

	if(m_iMode==4 && !(m_sSrv1=="" || m_sSrv1=="*"))
		{
		m_bIsSrv1Ok = 0;
		}

	if(m_iMode==4 && !(m_sSrv2=="" || m_sSrv2=="*"))
		{
		m_bIsSrv2Ok = 0;
		}

	GetDlgItem(IDC_EDIT6 )->EnableWindow(!m_iMode   || m_iMode==4);
	GetDlgItem(IDC_EDIT5 )->EnableWindow(!m_iMode   || m_iMode==4);
	GetDlgItem(IDC_EDIT4 )->EnableWindow(!m_iMode   || m_iMode==4);
	GetDlgItem(IDC_EDIT3 )->EnableWindow(!m_bIsDhcp && m_iMode <4);
	GetDlgItem(IDC_RADIO3)->EnableWindow(!m_bIsDhcp);
	GetDlgItem(IDC_RADIO4)->EnableWindow(!m_bIsDhcp);
	GetDlgItem(IDC_RADIO5)->EnableWindow(!m_bIsDhcp);
	GetDlgItem(IDC_RADIO6)->EnableWindow(!m_bIsDhcp);

	if(bOldN!=m_bIsNameOk || bOldA!=m_bIsAddrOk || bOldM!=m_bIsMaskOk || bOldG!=m_bIsGateOk || bOld1!=m_bIsSrv1Ok || bOld2!=m_bIsSrv2Ok)
		{
		RedrawWindow();
		}

}


//*****************************************************************************
//*
//*		OnInitDialog
//*
//*****************************************************************************
//  Behandlungsroutinen fr Nachrichten CKeyDialog
BOOL CKeyDialog::OnInitDialog()
{
NetCardInfo    *pInfo;
CComboBox	   *pCombo;	
CString			sText;
CRegKeys		sKey;
int				iPos;


	sKey.Open(HKEY_CURRENT_USER,"Software\\AZ\\IpSwitcher\\Keys");

	if(m_sName!="" && sKey.Up(m_sName,TRUE))
		{
		sKey.Get(m_sSrv2,"NameServer2");
		sKey.Get(m_sSrv1,"NameServer1");
		sKey.Get(m_sMask,"SubnetMask" );
		sKey.Get(m_sAddr,"IpAddress"  );
		sKey.Get(m_sCard,"MacOfCard"  );
		sKey.Get(m_sGate,"Gateway"    );
		sKey.Get(m_iMode,"Mode"       );
		}

	m_sOldSrv2 = m_sSrv2;
	m_sOldSrv1 = m_sSrv1;
	m_sOldGate = m_sGate;
	m_sOldCard = m_sCard;
	m_sOldName = m_sName;
	m_sOldAddr = m_sAddr;
	m_sOldMask = m_sMask; 
	m_iOldMode = m_iMode;

	pCombo     = GetDlgComboBox(IDC_COMBO1);

	for(iPos=0;iPos<64;iPos++)
		{
			pInfo = NetGetCardInfo(iPos);
		if(!pInfo)break;

		sText  = pInfo->cInfoName;
		sText += " :  ";
		sText += pInfo->cDesciption;
		pCombo->AddString(sText);

		if(stricmp(m_sCard,pInfo->cMac))continue;
		m_iCard = iPos;
		}

	if(stricmp(m_sAddr,"DHCP") && m_sMask=="")
		{
		if(atoi(m_sAddr)== 10)m_sMask = "255.255.0.0";
		else                  m_sMask = "255.255.255.0";
		}


	CDialog::OnInitDialog();


return TRUE; 
}

//*****************************************************************************
//*
//*		OnOK
//*
//*****************************************************************************
void CKeyDialog::OnOK()
{
NetCardInfo    *pInfo;
CRegKeys		sKey;


	UpdateData();

	if(!m_bIsNameOk){MessageBox("Du hast einen falschen Namen angegeben !"       ,"Fehler",MB_OK|MB_ICONERROR);return ;}
	if(!m_bIsAddrOk){MessageBox("Du hast eine falsche IP-adresse angegeben !"    ,"Fehler",MB_OK|MB_ICONERROR);return ;}
	if(!m_bIsMaskOk){MessageBox("Du hast einen falsche Subnet-Maske  angegeben !","Fehler",MB_OK|MB_ICONERROR);return ;}
	if(!m_bIsGateOk){MessageBox("Du hast ein falsches Gateway angegeben !"       ,"Fehler",MB_OK|MB_ICONERROR);return ;}
	if(!m_bIsSrv1Ok){MessageBox("Du hast einen falsche Name-Server-1 angegeben !","Fehler",MB_OK|MB_ICONERROR);return ;}
	if(!m_bIsSrv2Ok){MessageBox("Du hast einen falsche Name-Server-2 angegeben !","Fehler",MB_OK|MB_ICONERROR);return ;}


	if(m_bIsDhcp)
		{
		m_sAddr.MakeUpper();
		m_sMask = "";

		if(m_iMode>2)
			{
			MessageBox("Dieser Modus kann nicht mit einem DHCP-Server verwendet werden !","Fehler",MB_OK|MB_ICONERROR);
			return;
			}
		}


	sKey.Open(HKEY_CURRENT_USER,"Software\\AZ\\IpSwitcher\\Keys");

	if(m_sOldName!="" && m_sName!=m_sOldName)
		{
		sKey.DelKey(m_sOldName);
		}


	if(m_iCard>=0)
		{
		   pInfo = NetGetCardInfo(m_iCard);
		if(pInfo)m_sCard = pInfo->cMac;
		}	

	sKey.Up (m_sName);
	sKey.Set(m_sSrv2,"NameServer2");
	sKey.Set(m_sSrv1,"NameServer1");
	sKey.Set(m_sMask,"SubnetMask" );
	sKey.Set(m_sAddr,"IpAddress"  );
	sKey.Set(m_sCard,"MacOfCard"  );
	sKey.Set(m_sGate,"Gateway"    );
	sKey.Set(m_iMode,"Mode"       );

	m_bChanged = FALSE;
	
	if(m_sOldSrv2!=m_sSrv2)m_bChanged=TRUE;
	if(m_sOldSrv1!=m_sSrv1)m_bChanged=TRUE;
	if(m_sOldGate!=m_sGate)m_bChanged=TRUE;
	if(m_sOldCard!=m_sCard)m_bChanged=TRUE;
	if(m_sOldName!=m_sName)m_bChanged=TRUE;
	if(m_sOldAddr!=m_sAddr)m_bChanged=TRUE;
	if(m_sOldMask!=m_sMask)m_bChanged=TRUE; 
	if(m_iOldMode!=m_iMode)m_bChanged=TRUE;
	


	CDialog::OnOK();
}

//*****************************************************************************
//*
//*		OnCancel
//*
//*****************************************************************************
void CKeyDialog::OnCancel()
{

	CDialog::OnCancel();
}

//*****************************************************************************
//*
//*		OnChangeAddr
//*
//*****************************************************************************
void CKeyDialog::OnChangeAddr()
{

	UpdateData();

}

//*****************************************************************************
//*
//*		OnChangeName
//*
//*****************************************************************************
void CKeyDialog::OnChangeName()
{

	UpdateData();

}

//*****************************************************************************
//*
//*		OnChangeMask
//*
//*****************************************************************************
void CKeyDialog::OnChangeMask()
{

	UpdateData();

}

//*****************************************************************************
//*
//*		OnChangeGate
//*
//*****************************************************************************
void CKeyDialog::OnChangeGate()
{

	UpdateData();

}

//*****************************************************************************
//*
//*		OnChangeSrv1
//*
//*****************************************************************************
void CKeyDialog::OnChangeSrv1()
{

	UpdateData();

}

//*****************************************************************************
//*
//*		OnChangeSrv2
//*
//*****************************************************************************
void CKeyDialog::OnChangeSrv2()
{

	UpdateData();

}

//*****************************************************************************
//*
//*		OnCtlColor
//*
//*****************************************************************************
HBRUSH CKeyDialog::OnCtlColor(CDC *pDC,CWnd *pWnd,UINT nCtlColor) 
{
HBRUSH		hBrush;



	hBrush = CDialog::OnCtlColor(pDC,pWnd,nCtlColor);

	if(nCtlColor!=CTLCOLOR_EDIT)return hBrush;

	switch(GetWndId(pWnd))
		{
	case IDC_EDIT1:	if(m_bIsNameOk)return hBrush;	break;
	case IDC_EDIT2:	if(m_bIsAddrOk)return hBrush;	break;
	case IDC_EDIT3:	if(m_bIsMaskOk)return hBrush;	break;
	case IDC_EDIT4:	if(m_bIsGateOk)return hBrush;	break;
	case IDC_EDIT5:	if(m_bIsSrv1Ok)return hBrush;	break;
	case IDC_EDIT6:	if(m_bIsSrv2Ok)return hBrush;	break;
	default:					   return hBrush;	break;	
		}

	pDC->SetBkColor(RGB(255,128,128));
	

return m_hErrBrush;	
}

//*****************************************************************************
//*
//*		OnButton1
//*
//*****************************************************************************
void CKeyDialog::OnButton1() 
{
	UpdateData();
	m_sMask = "255.255.0.0";
	UpdateData(FALSE);
}

//*****************************************************************************
//*
//*		OnButton2
//*
//*****************************************************************************
void CKeyDialog::OnButton2() 
{
	UpdateData();
	m_sMask = "255.255.255.0";
	UpdateData(FALSE);
}

//*****************************************************************************
//*
//*		OnButton3
//*
//*****************************************************************************
void CKeyDialog::OnButton3() 
{
	UpdateData();
	m_sMask = "255.255.255.224";
	UpdateData(FALSE);
}

//*****************************************************************************
//*
//*		OnRadio
//*
//*****************************************************************************
void CKeyDialog::OnRadio() 
{
	UpdateData();
}
